create or replace PROCEDURE USR_EXP_NOTA_ENTRADA(P_CDFILIAL IN VARCHAR2,
                               P_DATAINI IN DATE,
                               P_DATAFIN IN DATE)
IS
   /* NOTA FISCAL */
   V_CDFILIAL VARCHAR2(4);
   V_NRLANCTO VARCHAR2(10);
   V_CDUNICO  VARCHAR2(14);
   V_IDENTSAI VARCHAR2(1);
   V_CDEMPRES VARCHAR2(2);
   V_FILIRECE VARCHAR2(4);
   V_NRINSJUR VARCHAR2(20);
   V_SERIENF  VARCHAR2(5);
   V_NRNOTAFI VARCHAR2(20);
   V_MODELO   VARCHAR2(2);
   V_DTEMISS  DATE;
   V_DTENTSAI DATE;
   V_NRACESSO VARCHAR2(50);
   V_VRNOTAFI FLOAT;
   V_IDOPDEV  VARCHAR2(1);
   V_CNPJ_MAE VARCHAR2(21);
   V_IDOPERAC VARCHAR2(1);
   V_CDFILREL VARCHAR2(4);
   V_NRLANREL VARCHAR2(10);
   V_NRNOTORI VARCHAR2(20);
   V_SERIEORI VARCHAR2(5);
   V_TIPOOPER VARCHAR2(2);
   /* VENCIMENTOS */
   V_NRSEQVEN VARCHAR2(2);
   V_DTATUREC DATE;
   V_VRATUREC FLOAT;
   V_DTVENCI1 DATE;
   V_VRVENCI1 FLOAT;
   V_DTVENCI2 DATE;
   V_VRVENCI2 FLOAT;
   V_DTVENCI3 DATE;
   V_VRVENCI3 FLOAT;
   V_DTVENCI4 DATE;
   V_VRVENCI4 FLOAT;
   V_DTVENCI5 DATE;
   V_VRVENCI5 FLOAT;
   V_DTVENCI6 DATE;
   V_VRVENCI6 FLOAT;
   /* ITENS */
   V_NRSEQITE VARCHAR2(4);
   V_CDARVPRO VARCHAR2(20);
   V_QUANTID  FLOAT;
   V_VRUNITA  FLOAT;
   V_VRDESCIT FLOAT;
   V_VRTOTAIT FLOAT;
   /* IMPOSTOS */
   V_CFOPITEM VARCHAR2(11);
   V_CODCFOP  VARCHAR2(11);
   V_VRBASEIT FLOAT;
   V_VRALIQIT FLOAT;
   V_VRIMPOIT FLOAT;
   V_CDIMPONF FLOAT;
   /* ICMS */
   V_BASEICMS FLOAT;
   V_ALIQICMS FLOAT;
   V_IMPOICMS FLOAT;
   /* PIS */
   V_BASEPIS  FLOAT;
   V_ALIQPIS  FLOAT;
   V_IMPOPIS  FLOAT;
   /* COFINS */
   V_BASECOFI FLOAT;
   V_ALIQCOFI FLOAT;
   V_IMPOCOFI FLOAT;
   /* IPI */
   V_BASEIPI  FLOAT;
   V_ALIQIPI  FLOAT;
   V_IMPOIPI  FLOAT;
   /* ICMS-ST */
   V_BASEICST FLOAT;
   V_ALIQICST FLOAT;
   V_IMPOICST FLOAT;
   /* EXCECAO */
   V_MENSERRO VARCHAR2(250);

   V_DTGRV      VARCHAR2(10);
   V_HRGRV      VARCHAR2(04);
   V_NFJAEXIST  INTEGER;
   V_NOVOCODIGO INTEGER;

   V_VRFRETE    FLOAT;
   V_VRDESCONTO FLOAT;

   /* NOTA FISCAL */
   CURSOR C_NOTA_ENTRADA(C_CDFILIAL IN VARCHAR2, C_DATAINI IN DATE, C_DATAFIN IN DATE) IS
      SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.CDEMPRESA, NF.CDFILIRECE, NF.NRINSJURNF,
             NF.CDSERIEENTR, NF.NRNOTAFISC, NF.CDMODDOCFISC, NF.DTEMISSAO, NF.DTENTRSAID, NF.NRACESSONFE,
             NF.VRNOTAFISC, NVL(TP.IDOPERDEVONF, 'N') IDOPERDEVONF, TP.CDTIPOOPER
        FROM NOTAFISCAL NF, TIPOOPERAC TP
       WHERE NF.IDENTRSAIDOP = TP.IDENTRSAIDOP
         AND NF.CDTIPOOPER   = TP.CDTIPOOPER
         AND TP.IDENTRSAIDOP = 'E'
         AND TP.CDTIPOOPER <> '04'
         AND NF.CDMODDOCFISC IS NOT NULL -- CODIGO DO MODELO OBRIGATORIO
         AND NF.USR_DTEXPORTACAO IS NULL
         AND NF.IDSTATUS = 'P'
         AND ((INSTR(C_CDFILIAL, '_'||NF.CDFILIRECE||'_')> 0) OR (C_CDFILIAL = 'T'))
         AND NF.DTENTRSAID BETWEEN C_DATAINI AND C_DATAFIN
         AND EXISTS (SELECT CDFILIAL
                       FROM CONTAPAGAR C
                      WHERE C.CDFILIAL = NF.CDFILIAL
                        AND C.NRLANCTONF = NF.NRLANCTONF);

   /* VENCIMENTOS DA NOTA FISCAL */
   CURSOR C_CONTAREC(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT LPAD(NRSEQVENPAG, 2, '0') AS NRSEQVENPAG, DTATUAVENPAG, VRATUAPAG
        FROM CONTAPAGAR
       WHERE CDFILIAL   = C_CDFILIAL
         AND NRLANCTONF = C_NRLANCTONF
       ORDER BY NRSEQVENPAG;

   /* ITENS DA NOTA FISCAL */
   CURSOR C_ITEMPRODUTO(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT I.NRSEQITPROD, P.CDARVPROD, I.QTITEMPROD, I.VRUNITITEM, I.VRDESCITEM, I.VRTOTAITEM, I.CDFISOPEITEM
        FROM ITEMPRODUTO I, PRODUTO P
       WHERE I.CDPRODUTO  = P.CDPRODUTO
         AND I.CDFILIAL   = C_CDFILIAL
         AND I.NRLANCTONF = C_NRLANCTONF;

   /* IMPOSTOS DOS ITENS DA NOTA FISCAL */
   CURSOR C_ITEMPROIMP(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2, C_NRSEQITEM IN VARCHAR2) IS
      SELECT MAX(IT.CDFISCOPERIT), MAX(IT.VRBASECALCIT), SUM(IT.VRALIQITEM), SUM(IT.VRIMPOSTOIT),
             IP.CDIMPOSTONFE
        FROM ITEMPROIMPOS IT, IMPOSTO IM, IMPOSTONFE IP
       WHERE IT.CDIMPOSTO    = IM.CDIMPOSTO
         AND IM.CDIMPOSTONFE = IP.CDIMPOSTONFE
         AND IT.CDFILIAL     = C_CDFILIAL
         AND IT.NRLANCTONF   = C_NRLANCTONF
         AND IT.NRSEQITPROD  = C_NRSEQITEM
         AND IP.CDIMPOSTONFE IN ('00', '50', '60', '10', '80')
       GROUP BY IP.CDIMPOSTONFE;
BEGIN
   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_CHAR(SYSDATE, 'DD/MM/YYYY'), TO_CHAR(SYSDATE,'HH24MI')
      INTO V_DTGRV, V_HRGRV
      FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   OPEN C_NOTA_ENTRADA(P_CDFILIAL, P_DATAINI, P_DATAFIN);
   LOOP
      FETCH C_NOTA_ENTRADA INTO V_CDFILIAL, V_NRLANCTO, V_IDENTSAI, V_CDEMPRES, V_FILIRECE, V_NRINSJUR,
                              V_SERIENF, V_NRNOTAFI, V_MODELO, V_DTEMISS, V_DTENTSAI, V_NRACESSO,
                              V_VRNOTAFI, V_IDOPDEV, V_TIPOOPER;
      EXIT WHEN C_NOTA_ENTRADA%NOTFOUND;
      V_CDUNICO  := V_CDFILIAL||V_NRLANCTO;
      V_NRNOTORI := NULL;
      V_SERIEORI := NULL;
      V_DTVENCI1 := NULL;
      V_VRVENCI1 := NULL;
      V_DTVENCI2 := NULL;
      V_VRVENCI2 := NULL;
      V_DTVENCI3 := NULL;
      V_VRVENCI3 := NULL;
      V_DTVENCI4 := NULL;
      V_VRVENCI4 := NULL;
      V_DTVENCI5 := NULL;
      V_VRVENCI5 := NULL;
      V_DTVENCI6 := NULL;
      V_VRVENCI6 := NULL;
      V_CNPJ_MAE := NULL;

      BEGIN
         OPEN C_CONTAREC(V_CDFILIAL, V_NRLANCTO);
         LOOP
            FETCH C_CONTAREC INTO V_NRSEQVEN, V_DTATUREC, V_VRATUREC;
            EXIT WHEN C_CONTAREC%NOTFOUND;
            IF (V_NRSEQVEN = '01') THEN
               V_DTVENCI1 := V_DTATUREC;
               V_VRVENCI1 := V_VRATUREC;
            ELSIF (V_NRSEQVEN = '02') THEN
               V_DTVENCI2 := V_DTATUREC;
               V_VRVENCI2 := V_VRATUREC;
            ELSIF (V_NRSEQVEN = '03') THEN
               V_DTVENCI3 := V_DTATUREC;
               V_VRVENCI3 := V_VRATUREC;
            ELSIF (V_NRSEQVEN = '04') THEN
               V_DTVENCI4 := V_DTATUREC;
               V_VRVENCI4 := V_VRATUREC;
            ELSIF (V_NRSEQVEN = '05') THEN
               V_DTVENCI5 := V_DTATUREC;
               V_VRVENCI5 := V_VRATUREC;
            ELSIF (V_NRSEQVEN = '06') THEN
               V_DTVENCI6 := V_DTATUREC;
               V_VRVENCI6 := V_VRATUREC;
            END IF;
         END LOOP;
         CLOSE C_CONTAREC;
      EXCEPTION
         WHEN OTHERS THEN
            CLOSE C_CONTAREC;
            RAISE;
      END;

      BEGIN
         SELECT NRINSJURFILI
           INTO V_CNPJ_MAE
           FROM FILIAL
          WHERE CDFILIAL = V_FILIRECE;
      EXCEPTION
         WHEN OTHERS THEN
            V_CNPJ_MAE := NULL;
      END;

      IF (V_TIPOOPER = '06') THEN
         V_IDOPERAC := 'B';
      ELSIF (V_IDOPDEV = 'S') THEN
         V_IDOPERAC := 'D';

         BEGIN
            SELECT CDFILIALIT, NRLANCTONFIT
              INTO V_CDFILREL, V_NRLANREL
              FROM ITEMNOTAFISC
             WHERE CDFILIAL   = V_CDFILIAL
               AND NRLANCTONF = V_NRLANCTO;
         EXCEPTION
            WHEN OTHERS THEN
               V_CDFILREL := NULL;
               V_NRLANREL := NULL;
         END;

         BEGIN
            SELECT NRNOTAFISC, CDSERIE
              INTO V_NRNOTORI, V_SERIEORI
              FROM NOTAFISCAL
             WHERE CDFILIAL   = V_CDFILREL
               AND NRLANCTONF = V_NRLANREL;
         EXCEPTION
            WHEN OTHERS THEN
               V_NRNOTORI := NULL;
               V_SERIEORI := NULL;
         END;
      ELSE
         V_IDOPERAC := V_IDOPDEV;
      END IF;

      /* Verifica existncia da Nota Fiscal */
      BEGIN
      SELECT NVL(MAX(USR_IDNOTAFISCAL),0)
        INTO V_NFJAEXIST
        FROM USR_PROT_NOTAFISCAL
       WHERE CDUNICO = V_CDUNICO
         AND IDINTERFACE = '1';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NFJAEXIST := 0;
      END;

      BEGIN
         SELECT NVL(I.VRITEMENCA, 0)
           INTO V_VRFRETE
           FROM ITEMENCARGO I, ENCARGONFE E, ENCARGO P
          WHERE E.CDENCARGONFE = '01'
            AND I.CDFILIAL = V_CDFILIAL
            AND I.NRLANCTONF = V_NRLANCTO
            AND P.CDENCARGONFE = E.CDENCARGONFE
            AND I.CDENCARGO = P.CDENCARGO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRFRETE := 0;
      END;

      BEGIN
         SELECT NVL(I.VRITEMENCA, 0)
           INTO V_VRDESCONTO
           FROM ITEMENCARGO I, ENCARGONFE E, ENCARGO P
          WHERE E.CDENCARGONFE = '03'
            AND I.CDFILIAL = V_CDFILIAL
            AND I.NRLANCTONF = V_NRLANCTO
            AND P.CDENCARGONFE = E.CDENCARGONFE
            AND I.CDENCARGO = P.CDENCARGO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRDESCONTO := 0;
      END;

      /* Se j possui a nota fiscal sera incluido um novo registro de excluso da mesma */
      IF V_NFJAEXIST <> 0 THEN

         /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT USR_IDNOTAFISCAL.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         FOR C_NF IN (SELECT CDUNICO, IDENTRSAID, CDEMPRESA, CDFILIAL, CDINSCRICAO, CDSERIE, NRNUMERO,
                             CDMODELO, DTEMISSAO, DTENTRADA, NRACESSONFE, VRTOTALNF, CNPJ_EMP_MAE,
                             NF_ORIGINAL, SERIE_ORIGINAL, DT_VENCIMENTO1, VR_VENCIMENTO1,
                             DT_VENCIMENTO2, VR_VENCIMENTO2, DT_VENCIMENTO3, VR_VENCIMENTO3,
                             DT_VENCIMENTO4, VR_VENCIMENTO4, DT_VENCIMENTO5, VR_VENCIMENTO5,
                             DT_VENCIMENTO6, VR_VENCIMENTO6, IDOPERACAO, VRFRETE, VRDESCONTO
                        FROM USR_PROT_NOTAFISCAL
                       WHERE USR_IDNOTAFISCAL = V_NFJAEXIST)
         LOOP
            INSERT INTO USR_PROT_NOTAFISCAL(USR_IDNOTAFISCAL, CDUNICO, IDENTRSAID, CDEMPRESA, CDFILIAL, CDINSCRICAO, CDSERIE, NRNUMERO,
                                            CDMODELO, DTEMISSAO, DTENTRADA, NRACESSONFE, VRTOTALNF, CNPJ_EMP_MAE,
                                            NF_ORIGINAL, SERIE_ORIGINAL, DT_VENCIMENTO1, VR_VENCIMENTO1,
                                            DT_VENCIMENTO2, VR_VENCIMENTO2, DT_VENCIMENTO3, VR_VENCIMENTO3,
                                            DT_VENCIMENTO4, VR_VENCIMENTO4, DT_VENCIMENTO5, VR_VENCIMENTO5,
                                            DT_VENCIMENTO6, VR_VENCIMENTO6, IDOPERACAO, IDINTERFACE, STATUS, LOG_ERRO,
                                            DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO, VRFRETE, VRDESCONTO)
            VALUES(V_NOVOCODIGO, C_NF.CDUNICO, C_NF.IDENTRSAID, C_NF.CDEMPRESA, C_NF.CDFILIAL, C_NF.CDINSCRICAO, C_NF.CDSERIE, C_NF.NRNUMERO,
                   C_NF.CDMODELO, C_NF.DTEMISSAO, C_NF.DTENTRADA, C_NF.NRACESSONFE, C_NF.VRTOTALNF, C_NF.CNPJ_EMP_MAE,
                   C_NF.NF_ORIGINAL, C_NF.SERIE_ORIGINAL, C_NF.DT_VENCIMENTO1, C_NF.VR_VENCIMENTO1,
                   C_NF.DT_VENCIMENTO2, C_NF.VR_VENCIMENTO2, C_NF.DT_VENCIMENTO3, C_NF.VR_VENCIMENTO3,
                   C_NF.DT_VENCIMENTO4, C_NF.VR_VENCIMENTO4, C_NF.DT_VENCIMENTO5, C_NF.VR_VENCIMENTO5,
                   C_NF.DT_VENCIMENTO6, C_NF.VR_VENCIMENTO6, C_NF.IDOPERACAO, '2', 'A', NULL,
                   V_DTGRV, V_HRGRV, NULL, NULL, C_NF.VRFRETE, C_NF.VRDESCONTO);

            FOR C_PRODNF IN (SELECT CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE, VRUNITARIO, VRDESCITEM,
                                    VRTOTAITEM, CFO_ITEM, VRBASECALCICMS, VRALIQICMS, VRIMPOSTOICMS,
                                    VRBASECALCPIS, VRALIQPIS, VRIMPOSTOPIS, VRBASECALCCOFINS, VRALIQCOFINS,
                                    VRIMPOSTOCOFINS, VRBASECALCIPI, VRALIQIPI, VRIMPOSTOIPI, VRBASECALCICMSST,
                                    VRALIQICMSST, VRIMPOSTOICMSST, STATUS, LOG_ERRO, IDINTERFACE, DTGRAVACAO,
                                    HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO
                               FROM USR_PROT_ITEMPRODUTO
                              WHERE USR_IDNOTAFISCAL = V_NFJAEXIST)
            LOOP
               INSERT INTO USR_PROT_ITEMPRODUTO(USR_IDNOTAFISCAL, CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE, VRUNITARIO, VRDESCITEM,
                                                VRTOTAITEM, CFO_ITEM, VRBASECALCICMS, VRALIQICMS, VRIMPOSTOICMS,
                                                VRBASECALCPIS, VRALIQPIS, VRIMPOSTOPIS, VRBASECALCCOFINS, VRALIQCOFINS,
                                                VRIMPOSTOCOFINS, VRBASECALCIPI, VRALIQIPI, VRIMPOSTOIPI, VRBASECALCICMSST,
                                                VRALIQICMSST, VRIMPOSTOICMSST, STATUS, LOG_ERRO, IDINTERFACE, DTGRAVACAO,
                                                HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO)
               VALUES(V_NOVOCODIGO, C_PRODNF.CDUNICO, C_PRODNF.NRSEQITEM, C_PRODNF.CDPRODUTO, C_PRODNF.VRQUANTIDADE, C_PRODNF.VRUNITARIO, C_PRODNF.VRDESCITEM,
                      C_PRODNF.VRTOTAITEM, C_PRODNF.CFO_ITEM, C_PRODNF.VRBASECALCICMS, C_PRODNF.VRALIQICMS, C_PRODNF.VRIMPOSTOICMS,
                      C_PRODNF.VRBASECALCPIS, C_PRODNF.VRALIQPIS, C_PRODNF.VRIMPOSTOPIS, C_PRODNF.VRBASECALCCOFINS, C_PRODNF.VRALIQCOFINS,
                      C_PRODNF.VRIMPOSTOCOFINS, C_PRODNF.VRBASECALCIPI, C_PRODNF.VRALIQIPI, C_PRODNF.VRIMPOSTOIPI, C_PRODNF.VRBASECALCICMSST,
                      C_PRODNF.VRALIQICMSST, C_PRODNF.VRIMPOSTOICMSST, 'A', NULL, '2', V_DTGRV,
                      V_HRGRV, NULL, NULL);
            END LOOP;
         END LOOP;
      END IF;

      /* Retorna o sequencial para a tabela */
      BEGIN
         SELECT USR_IDNOTAFISCAL.NEXTVAL
           INTO V_NOVOCODIGO
           FROM DUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NOVOCODIGO := 1;
      END;

      INSERT INTO USR_PROT_NOTAFISCAL(USR_IDNOTAFISCAL, CDUNICO, IDENTRSAID, CDEMPRESA, CDFILIAL, CDINSCRICAO, CDSERIE, NRNUMERO,
                                      CDMODELO, DTEMISSAO, DTENTRADA, NRACESSONFE, VRTOTALNF, CNPJ_EMP_MAE,
                                      NF_ORIGINAL, SERIE_ORIGINAL, DT_VENCIMENTO1, VR_VENCIMENTO1,
                                      DT_VENCIMENTO2, VR_VENCIMENTO2, DT_VENCIMENTO3, VR_VENCIMENTO3,
                                      DT_VENCIMENTO4, VR_VENCIMENTO4, DT_VENCIMENTO5, VR_VENCIMENTO5,
                                      DT_VENCIMENTO6, VR_VENCIMENTO6, IDOPERACAO, IDINTERFACE, STATUS, LOG_ERRO,
                                      DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO, VRFRETE, VRDESCONTO)
      VALUES(V_NOVOCODIGO, V_CDUNICO, V_IDENTSAI, V_CDEMPRES, V_FILIRECE, V_NRINSJUR, V_SERIENF, V_NRNOTAFI,
             V_MODELO, V_DTEMISS, V_DTENTSAI, V_NRACESSO, V_VRNOTAFI, V_CNPJ_MAE,
             V_NRNOTORI, V_SERIEORI, V_DTVENCI1, V_VRVENCI1,
             V_DTVENCI2, V_VRVENCI2, V_DTVENCI3, V_VRVENCI3,
             V_DTVENCI4, V_VRVENCI4, V_DTVENCI5, V_VRVENCI5,
             V_DTVENCI6, V_VRVENCI6, V_IDOPERAC, '1', 'A', NULL,
             V_DTGRV, V_HRGRV, NULL, NULL, V_VRFRETE, V_VRDESCONTO);

      BEGIN
         OPEN C_ITEMPRODUTO(V_CDFILIAL, V_NRLANCTO);
         LOOP
            FETCH C_ITEMPRODUTO INTO V_NRSEQITE, V_CDARVPRO, V_QUANTID, V_VRUNITA, V_VRDESCIT, V_VRTOTAIT, V_CODCFOP;
            EXIT WHEN C_ITEMPRODUTO%NOTFOUND;
            V_BASEICMS := NULL;
            V_ALIQICMS := NULL;
            V_IMPOICMS := NULL;
            V_BASEPIS  := NULL;
            V_ALIQPIS  := NULL;
            V_IMPOPIS  := NULL;
            V_BASECOFI := NULL;
            V_ALIQCOFI := NULL;
            V_IMPOCOFI := NULL;
            V_BASEIPI  := NULL;
            V_ALIQIPI  := NULL;
            V_IMPOIPI  := NULL;
            V_BASEICST := NULL;
            V_ALIQICST := NULL;
            V_IMPOICST := NULL;

            BEGIN
               OPEN C_ITEMPROIMP(V_CDFILIAL, V_NRLANCTO, V_NRSEQITE);
               LOOP
                  FETCH C_ITEMPROIMP INTO V_CFOPITEM, V_VRBASEIT, V_VRALIQIT, V_VRIMPOIT, V_CDIMPONF;
                  EXIT WHEN C_ITEMPROIMP%NOTFOUND;
                  V_CODCFOP := NVL(V_CFOPITEM, V_CODCFOP);

                  IF V_CDIMPONF = '00' THEN
                     V_BASEICMS := V_VRBASEIT;
                     V_ALIQICMS := V_VRALIQIT;
                     V_IMPOICMS := V_VRIMPOIT;
                  ELSIF V_CDIMPONF = '50' THEN
                     V_BASEPIS  := V_VRBASEIT;
                     V_ALIQPIS  := V_VRALIQIT;
                     V_IMPOPIS  := V_VRIMPOIT;
                  ELSIF V_CDIMPONF = '60' THEN
                     V_BASECOFI := V_VRBASEIT;
                     V_ALIQCOFI := V_VRALIQIT;
                     V_IMPOCOFI := V_VRIMPOIT;
                  ELSIF V_CDIMPONF = '10' THEN
                     V_BASEIPI  := V_VRBASEIT;
                     V_ALIQIPI  := V_VRALIQIT;
                     V_IMPOIPI  := V_VRIMPOIT;
                  ELSIF V_CDIMPONF = '80' THEN
                     V_BASEICST := V_VRBASEIT;
                     V_ALIQICST := V_VRALIQIT;
                     V_IMPOICST := V_VRIMPOIT;
                  END IF;
               END LOOP;
               CLOSE C_ITEMPROIMP;
            EXCEPTION
               WHEN OTHERS THEN
                  CLOSE C_ITEMPROIMP;
                  RAISE;
            END;

            INSERT INTO USR_PROT_ITEMPRODUTO(USR_IDNOTAFISCAL, CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE, VRUNITARIO, VRDESCITEM,
                                             VRTOTAITEM, CFO_ITEM, VRBASECALCICMS, VRALIQICMS, VRIMPOSTOICMS,
                                             VRBASECALCPIS, VRALIQPIS, VRIMPOSTOPIS, VRBASECALCCOFINS, VRALIQCOFINS,
                                             VRIMPOSTOCOFINS, VRBASECALCIPI, VRALIQIPI, VRIMPOSTOIPI, VRBASECALCICMSST,
                                             VRALIQICMSST, VRIMPOSTOICMSST, STATUS, LOG_ERRO, IDINTERFACE, DTGRAVACAO,
                                             HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO)
            VALUES(V_NOVOCODIGO, V_CDUNICO, V_NRSEQITE, V_CDARVPRO, V_QUANTID, V_VRUNITA, V_VRDESCIT,
                   V_VRTOTAIT, V_CODCFOP, V_BASEICMS, V_ALIQICMS, V_IMPOICMS,
                   V_BASEPIS, V_ALIQPIS, V_IMPOPIS, V_BASECOFI, V_ALIQCOFI,
                   V_IMPOCOFI, V_BASEIPI, V_ALIQIPI, V_IMPOIPI, V_BASEICST,
                   V_ALIQICST, V_IMPOICST, 'A', NULL, '1', V_DTGRV,
                   V_HRGRV, NULL, NULL);
         END LOOP;
         CLOSE C_ITEMPRODUTO;
      EXCEPTION
         WHEN OTHERS THEN
            CLOSE C_ITEMPRODUTO;
            RAISE;
      END;

      UPDATE NOTAFISCAL
         SET USR_DTEXPORTACAO = SYSDATE
       WHERE CDFILIAL   = V_CDFILIAL
         AND NRLANCTONF = V_NRLANCTO;
   END LOOP;
   CLOSE C_NOTA_ENTRADA;

   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      V_MENSERRO := SQLERRM(SQLCODE);
      RAISE_APPLICATION_ERROR(-20501, 'Erro: '||V_MENSERRO, TRUE);
      CLOSE C_NOTA_ENTRADA;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXP_NOTA_ENTRADA','5.85.XXX'); END;
/
